//+------------------------------------------------------------------+
//|                                                   i-WCCI_TLB.mq4 |
//|                                               4 KimIV |
//+------------------------------------------------------------------+
#property copyright "Ace, KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window
#property indicator_buffers 1

#property indicator_color1 CadetBlue

//-------   ------------------------------------------
extern int CCIP  = 14;  //  CCI
extern int limit = 90;  //     
extern int delta = 25;  //   ""  ""
extern int KBars = 5000;
//, yyyy(0), mm(0), dd(0), hh(0), mn(0)

//-------   ------------------------------------------
double WCCI_TLB[];

//-------   --------------------------------------
bool firstTime = True;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  SetIndexBuffer(0, WCCI_TLB);
  SetIndexStyle (0, DRAW_ARROW);
  SetIndexArrow (0, 131);
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  Comment("");
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  datetime tmn1, tmn2;
  double   tt[20];
  double   pmn1, pmn2, pmx1, pmx2, tmx1, tmx2, kmx, kmn, line;
  int      loopbegin, shift, sh;
  int      cciU, cciD;

  if (firstTime) {
  	if (KBars==0) {
  		loopbegin = Bars - 1;
	  }	else {
  		loopbegin = KBars - 1;
	  }
  }
  for (shift=loopbegin; shift>=0; shift--) {
  	WCCI_TLB[shift] = 0;
  	cciU = 0;
  	cciD = 0;
  	for (sh=0; sh<=17; sh++) {
      //   .
  		tt[sh] = iCCI(NULL, 0, CCIP, PRICE_TYPICAL, shift+sh);
      //   .
		  if (sh<=8) {
			  if (tt[sh]>=0) cciU++;
  			else cciD++;
  		}
  	}

  	pmx1 = 0;
  	pmx2 = 0;
  	kmx = 0;
    //   .
  	if (cciD>=6) {
  		for (sh=0; sh<=17; sh++) {
  			if (tt[sh]<=tt[sh+1] && tt[sh+1]>=tt[sh+2]) {
  				if (pmx1!=0 && pmx2==0) {
  					pmx2 = tt[sh+1];
  					tmx2 = Time[sh+1+shift];
  					kmx = 100 * (pmx2 - pmx1) / (tmx2 - tmx1);
  				}
  				if (pmx1==0) {
  					pmx1 = tt[sh+1];
  					tmx1 = Time[sh+1+shift];
  				}
  			}
  		}
  	}

  	pmn1 = 0;
  	pmn2 = 0;
  	kmn = 0;
    //   .
  	if (cciU>=6) {
  		for (sh=0; sh<=17; sh++) {
  			if (tt[sh]>=tt[sh+1] && tt[sh+1]<=tt[sh+2]) {
  				if (pmn1!=0 && pmn2==0) {
  					pmn2 = tt[sh+1];
  					tmn2 = Time[sh+1+shift];
  					kmn = 100 * (pmn2 - pmn1) / (tmn2 - tmn1);
  				}
  				if (pmn1==0) {
  					pmn1 = tt[sh+1];
  					tmn1 = Time[sh+1+shift];
  				}
  			}
  		}
  	}

    // TLB ctr   
  	if (kmx!=0 && cciD>=6	&& (pmx1<-limit || pmx2<-limit)) {
  		line = (Time[shift] - tmx1) * kmx / 100 + pmx1;
  		if (tt[1]<line && tt[0]>=line) {
				WCCI_TLB[shift] = Low[shift] - 5 * Point;
			}
  	}
	
    // TLB ctr   
  	if (kmn!=0 && cciU >=6 && (pmn1>limit || pmn2>limit)) {
  		line = (Time[shift] - tmn1) * kmn / 100 + pmn1;
  		if (tt[1]>line && tt[0]<=line) {
  			WCCI_TLB[shift] = High[shift] + 5 * Point;
  		}
  	}
  	loopbegin = loopbegin - 1;
  }
}
//+------------------------------------------------------------------+

